config/routes.rb
Rails.application.routes.draw do
	scope "(:locale)", locale: /en|fa/ do
		resources :posts
		# devise_for :users
		devise_for :users, :controllers => { :registrations => 'registrations' }
		# For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

		# root to: "users#new"
		root to: "page#index"
		# get '/users/:id', to 'users'
		get 'users/:username' => 'users#show'
		post 'relationship/follow' => 'relationship#follow'
		post 'relationship/unfollow' => 'relationship#unfollow'
		# get 'friends/' => 'relationship#show_friends'

		# get 'friends/', to: 'relationship#show_friends'
		get 'friends' => 'friends#index'

	end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/post.rb
class Post < ApplicationRecord
	validates :username, presence: true
	validates :context, presence: true, length: { maximum: 140 }

	belongs_to :user
end

app/models/relationship.rb
class Relationship < ApplicationRecord
	belongs_to :follower, class_name: "User"
	belongs_to :followed, class_name: "User"

	validates :follower_id, presence: true
	validates :followed_id, presence: true

end

app/models/user.rb
class User < ApplicationRecord
	# Include default devise modules. Others available are:
	# :confirmable, :lockable, :timeoutable and :omniauthable
	devise :database_authenticatable, :registerable,
		:recoverable, :rememberable, :trackable, :validatable

	has_many :posts, dependent: :destroy #remove a user's posts if his account is deleted!
	
	has_many :active_relationships, class_name: "Relationship", foreign_key: "follower_id", dependent: :destroy
	has_many :passive_relationships, class_name: "Relationship", foreign_key: "followed_id", dependent: :destroy

	has_many :followings, through: :active_relationships, source: :followed
	has_many :followers, through: :passive_relationships, source: :follower


	# follow another user
	def follow(other)
		active_relationships.create(followed_id: other.id)
	end

	# unfollow a user
	def unfollow(other)
		active_relationships.find_by(followed_id: other.id).destroy
	end

	# is following a user?
	def followings?(other)
		followings.include?(other)
	end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
	protect_from_forgery with: :exception
	before_filter :set_locale

private
	def set_locale
		I18n.locale = params[:locale] if params[:locale].present?

	end

	def default_url_options(option = {})
		{locale: I18n.locale} 
	end
end

app/controllers/friends_controller.rb
class FriendsController < ApplicationController
	def show_friends
		
	end

	def index
		
	end
end

app/controllers/page_controller.rb
class PageController < ApplicationController
	def index

		if current_user != nil

			@posts = []
			current_user.followings.each do |f|
				@posts = @posts + f.posts
			end
			@posts = @posts.sort_by(&:updated_at).reverse
		end

	end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: [:show, :edit, :update, :destroy]

  # GET /posts
  # GET /posts.json
  def index
    @posts = Post.all
  end

  # GET /posts/1
  # GET /posts/1.json
  def show
  end

  # GET /posts/new
  def new
    @post = Post.new
  end

  # GET /posts/1/edit
  def edit
  end

  # POST /posts
  # POST /posts.json
  def create
    @post = Post.new(post_params)
    @post.username = current_user.username
    @post.user_id = current_user.id
    
    # if current_user.nil?
    #   redirect_to 
    # end

    respond_to do |format|
      if @post.save
        format.html { redirect_to @post, notice: 'Post was successfully created.' }
        format.json { render :show, status: :created, location: @post }
      else
        format.html { render :new }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /posts/1
  # PATCH/PUT /posts/1.json
  def update
    respond_to do |format|
      if @post.update(post_params)
        format.html { redirect_to @post, notice: 'Post was successfully updated.' }
        format.json { render :show, status: :ok, location: @post }
      else
        format.html { render :edit }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /posts/1
  # DELETE /posts/1.json
  def destroy
    @post.destroy
    respond_to do |format|
      format.html { redirect_to posts_url, notice: 'Post was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_post
      @post = Post.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def post_params
      params.require(:post).permit(:username, :context)
    end
end

app/controllers/registrations_controller.rb
class RegistrationsController < Devise::RegistrationsController
	def create
    build_resource(registration_params)

    if resource.save
      if resource.active_for_authentication?
        set_flash_message :notice, :signed_up if is_navigational_format?
        sign_up(resource_name, resource)
        respond_with resource, :location => after_sign_up_path_for(resource)
      else
        set_flash_message :notice, :"signed_up_but_#{resource.inactive_message}" if is_navigational_format?
        respond_with resource, :location => after_sign_up_path_for(resource)
      end
    else
      clean_up_passwords
      respond_with resource
    end
  end  

  private

  def registration_params
    params.require(:user).permit(:email, :username, :password, :password_confirmation)
  end
end

app/controllers/relationship_controller.rb
class RelationshipController < ApplicationController

	# follow another user
	def follow
		user = User.find(params[:user_id])
		current_user.follow(user)
		redirect_to "/users/" + user.username
	end

	def unfollow
		user = User.find(params[:user_id])
		current_user.unfollow(user)
		redirect_to "/users/" + user.username
	end

end

app/controllers/users_controller.rb
class UsersController < ApplicationController
	def show
		# @user = User.find(params[:id])
		@user  = User.where(username: params[:username]).first
	end

	# # follow another user
	# def follow
	# 	fail
	# end

	# def unfollow
	# 	fail
	# end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/friends_helper.rb
module FriendsHelper
end

app/helpers/page_helper.rb
module PageHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/helpers/registrations_helper.rb
module RegistrationsHelper
end

app/helpers/relationship_helper.rb
module RelationshipHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/friends/index.html.erb
<% if current_user != nil %>
	<h2>Followings(<%= current_user.followings.count %>) </h2>
	<% current_user.followings.each do |f| %>
		<h4> &nbsp;&nbsp;&nbsp;&nbsp; 
			<%= link_to f.username,
			:controller => 'users', 
			:action => 'show', 
			:username => f.username %> </h4>
		
	<% end %>

	<h2>Followers(<%= current_user.followers.count %>) </h2>
	<% current_user.followers.each do |f| %>
		<h4> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
			<%= link_to f.username,
			:controller => 'users', 
			:action => 'show', 
			:username => f.username %> </h4>
		
	<% end %>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
	<head>
		<title><%= t('website_name') %></title>
		<meta charset="utf-8">
		<%= stylesheet_link_tag 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css'%>
		<%= javascript_include_tag :defaults %>
	</head>

	<body>
		<nav class="navbar navbar-inverse navbar-fixed-top" style="margin-bottom: 100px">
			<div class="container">
				<div class="navbar-header">
				<button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" 		aria-controls="navbar">
					<span class="sr-only">Toggle navigation</span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
				</button>
				<a class="navbar-brand" href="#"><%= t('website_name') %></a>
				</div>
				<div id="navbar" class="collapse navbar-collapse">
					<ul class="nav navbar-nav">
						<li> <%= link_to "Home", root_path %> </li>
						<li> <%= link_to "Sign In", new_user_session_path %> </li>
						<li> <%= link_to "Friends", friends_path %> </li>

					</ul>

					<ul class="nav navbar-nav navbar-right">
						<li> <%= link_to "Sign Up", new_user_registration_path %> </li>
						<li> <%= link_to "Sign Out", destroy_user_session_path %> </li>
					</ul>
				</div><!--/.nav-collapse -->
			</div>
		</nav>		

		<div class="container" style="margin-top: 50px">
		<div id="nav">
			Langages:
			<%= link_to_unless_current "English", locale: "en" %> |
			<%= link_to_unless_current "Farsi", locale: "fa" %>
		</div>

		<%= image_tag('logo.png', size: '50x50', :alt => "rss feed") %>

		<p class="notice"><%= notice %></p>
		<p class="alert"><%= alert %></p>
		<%= yield %>
		</div>

		<footer style="position:fixed;bottom: 15px;width: 100%;text-align: center;">Sahand Asri - Moein Sorkei</footer>
	</body>
</html>

app/views/page/follow.html.erb
<% if(urrent_user.nil? ) %>
	<h1>Please Sign-in !</h1>
<% else %>
	
<% end %>

app/views/page/index.html.erb
<h1><%= t('welcome_msg') %></h1>

<% if current_user.nil? %>

<% else %>
	<%= link_to "New Post", new_post_path,
	method: :get, 
	:class => 'btn btn-default' %>

	<h4> Your followers: <%= current_user.followers.count %> </h4>
	<h4> Your followings: <%= current_user.followings.count %> </h4>
	<h4> Your posts: <%= current_user.posts.count %> </h4>

	<h2>Posts: </h2>

		<% @posts.each do |p| %>

			<h4> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <%= p.username %>: </h4>
			<p> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <%= p.context %> </p>
		<% end %>



<% end %>

app/views/posts/_form.html.erb
<%= form_for(post) do |f| %>
  <% if post.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(post.errors.count, "error") %> prohibited this post from being saved:</h2>

      <ul>
      <% post.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :username %>
    <%= f.text_field :username %>
  </div>

  <div class="field">
    <%= f.label :context %>
    <%= f.text_area :context %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/posts/edit.html.erb
<h1>Editing Post</h1>

<%= render 'form', post: @post %>

<%= link_to 'Show', @post %> |
<%= link_to 'Back', posts_path %>

app/views/posts/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Posts</h1>

<table>
  <thead>
    <tr>
      <th>Username</th>
      <th>Context</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @posts.each do |post| %>

      <% if post.user_id == current_user.id %>

        <tr>
          <td><%= post.username %> &nbsp;&nbsp; </td>
          <td><%= post.context %> &nbsp;&nbsp; </td>
          <td><%= link_to 'Show', post %> &nbsp;&nbsp; </td>
          <td><%= link_to 'Edit', edit_post_path(post) %> &nbsp;&nbsp; </td>
          <td><%= link_to 'Destroy', post, method: :delete, data: { confirm: 'Are you sure?' } %> &nbsp;&nbsp; </td>
        </tr>
      <% end %>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Post', new_post_path %>

app/views/posts/new.html.erb
<h1>New Post</h1>

<%= form_for @post, url: {action: "create"} do |f| %>

	<% if current_user.nil? %>
		<div>Please Login!</div>
	<% else %>
		<% if @post.errors.any? %>
			<% @post.errors.full_messages.each do |msg| %>
				<div class="alert alert-danger"> <%= msg %> </div>
			<% end %>
		<% end %>

		<%= f.label :context %><br>
		<%= f.text_area :context %><br>
		<%= f.submit "Create" %>

	<% end %>
<% end %>

<%= link_to 'Back', posts_path %>

app/views/posts/show.html.erb
<p id="notice"><%= notice %></p>

<% if current_user.followings?(@post.user) || current_user == @post.user %>

	<p>
	  <strong>Username:</strong>
	  <%= @post.username %>
	</p>

	<p>
	  <strong>Context:</strong>
	  <%= @post.context %>
	</p>

	<%= link_to 'Edit', edit_post_path(@post) %> |
	<%= link_to 'Back', posts_path %>

<% else %>
	<p> You cannot see this post! </p>
<% end %>

app/views/users/show.html.erb
<h3> Username: <%= @user.username %> </h3>
<h5> Email: <%= @user.email %> </h5>

<% if current_user != nil %>

	<% if (current_user != @user) %>

		<% if !current_user.followings?(@user) %>
			<%= button_to "Follow", relationship_follow_path(user_id: @user.id), 
				:class => 'btn btn-default' %>
		<% else %>
			<%= button_to "Unfollow", relationship_unfollow_path(user_id: @user.id),
				:class => 'btn btn-default' %>
		<% end %>
		
	<% end %>

	<br>
	<% if current_user.followings?(@user) || current_user == @user %>
		<h3>Posts: </h3>
		<% @user.posts.reverse.each do |p| %>
			<p> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <%= p.context %> </p>
		<% end %>
	<% end %>

<% end %>